!+
! Module: epreject_mod
!
! Authors:  Konrad Dennerl, Hermann Brunner, Vadim Burwitz - MPE
! Co-Author:-)  Michael Freyberg - MPE
!
! Description:
!
! Comments:
!
! $Id: module.f90,v 1.5 1998/01/13 08:39:15 gvacanti Exp $
!-
module epreject_mod

  use eventAttributes
  use errorHandling
  use oal
  use cal
  use param
  use dal

  implicit none

  private

  public epreject

contains

  !---------------------------------------------------------------------
  subroutine epreject
  !---------------------------------------------------------------------

   implicit none

   character(len=13), parameter :: CodeVersion = '5.17'

   real(kind=Single) :: hmed, expo, exp1k, h1, h2, bg, bgfac, offsig
   real(kind=Single) :: map_min, map_max
   real(kind=Single), dimension(0:0), target :: rdum
   integer(kind=Int16), dimension(0:0), target :: i2dum
   integer(kind=Int32) :: i, j, k, ix, iy, ky, jy, ixx, iyy, nevent, kval, ndim
   integer(kind=Int32) :: koff, ksel, iccd, ccd, idum, isubmode, flagged
   integer(kind=Int32) :: noffcorr, ios = 0, badX, noffsets, nbadpix
   integer(kind=Int32) :: winX0, winX1, winY0, winY1, win4Y0
   integer(kind=Int32) :: count3, pix3, count5, pix5, nsou
   integer(kind=Int16) :: i2off, i2pha, j2pha
   integer             :: jccd, mccd, odilen
   integer(kind=Int16), parameter :: glc1 = 2, glc2 = 11
   integer(kind=Int16), parameter :: i2offmax = 19
   integer(kind=Int32), parameter :: nxdim=64, nydim=200, nyStart=13
   integer(kind=Int32), parameter :: nccd=12, minspec=16, maxspec=65, &
                                     maxoffcorr=500
   integer(kind=Int32), dimension(nccd,nydim,maxspec) :: i4spc
   integer(kind=Int32), dimension(nydim,maxspec) :: i4buf, i4buff
   integer(kind=Int32), dimension(nxdim,nydim) :: i4pmap, i30map
   integer(kind=Int32), dimension(nydim) :: i4arr1
   integer(kind=Int16), dimension(nxdim,nydim), target :: i2pmap
   real(kind=Single), dimension(nydim,maxspec) :: spcfrc
   real(kind=Single), dimension(0:12) :: noiseparam
   real(kind=Single), dimension(:), pointer :: XRLcoeff
   integer(kind=Int32), dimension(nydim)    :: i4med, indx
   real(kind=Single), dimension(:), pointer :: hlo, hhi
   integer(kind=Int16), dimension(:),     pointer :: val, rrawx
   real(kind=double), dimension(:),       pointer :: timeCol
   integer(kind=Int16), dimension(:),     pointer :: rawXCol, rawYCol, phaCol, offCol, xrlCol
   integer(kind=Int16), dimension(:),     pointer :: noiseCol, flareCol, offXCol, &
                                                     bpRawXCol, bpRawYCol, yExtCol !, odilist_ccdnrCol
   integer(kind=Int8), dimension(:),      pointer :: ccdCol
   integer(kind=Int16), dimension(:,:),   pointer :: i2offset, i2map
   integer(kind=Int16), dimension(:,:,:), pointer :: i3offset
   integer(kind=int32), dimension(2)              :: npix
   real(kind=Single), dimension(:,:),     pointer :: r4med
   real(kind=Single), dimension(:,:,:),   pointer :: noisemap
   real(kind=Single), dimension(:,:),     pointer :: MasterOffset
   real(kind=Single), dimension(:,:),     pointer :: MasterClosedOffset
   logical, dimension(1:nxdim,1:nydim)            :: mask = .false.
   logical :: exist, withoffsetmap, calibrated_noise, calibrated_offset, &
                     withnoisehandling, isfastmode = .false., &
                     withoffsetlist = .false., hasoffsetmap = .false.
   logical :: withsoftflarescreening = .FALSE.
   character(len=1024) :: string, fileName, shortFileName, odifile, set, odilist, odilistfile
   character(len=1024) :: odibase
   character(len=32)   :: submode, datamode
   character(len=4)    :: expidstr

   logical :: ldebug = .false., ldevel = .false. !  ldevel = .true.
   logical :: hasFILTER = .false., &
              hasOTFILTER = .false., &
              OTFILTER_Closed = .false., &
              hasEXPOSUREalloc = .false., &
              odilistfile_found = .false.
   character(len=32)   :: filter = 'UNDETERMINED'
   character(len=32)   :: ot_filter = 'UNDETERMINED'
   character(len=3 )   :: kw_rej_corr = 'YES'
   character(len=3 )   :: kw_xrl_corr = 'YES'

   logical(kind=bool), parameter :: enable_SCR_331 = .TRUE.  ! enable X-ray loading analysis
   logical(kind=bool), parameter :: enable_SCR_7199 = .TRUE. ! enable CCF/CAL value keyword


!--> epreject flare routine VB
   integer(kind=Int32), dimension(:), allocatable :: lc
   real(kind=single),   dimension(:), allocatable :: lcs
   real(kind=double)   :: tbinsize,t0,tz
   real(kind=double)   :: ss
   integer(kind=Int32) :: kmax,ndlc,sbox
   integer(kind=Int32) :: npharangeelements
!  integer(kind=Int32) :: nsmoothelements
   real(kind=double),   dimension(0:2) :: smo
   integer(kind=Int32), dimension(0:1) :: thrpha
   real(kind=double) :: thrsig

!<-- epreject flare routine VB

   type(DataSetT) :: infile, odiset, outfile ! , infile2  !, odfodi
   type(arrayT)   :: odiarr, ima  ! , odfarr
   type(TableT)   :: events, offsets, badpix, expos ! , intable2
   type(ColumnT)  :: ccdnr, rawX, rawY, pha, offCor, noise, flare, offX, xrlCor !, tempInCol
   type(ColumnT)  :: bpRawX, bpRawY, yExtent
   type(ColumnT)  :: time
!  type(ColumnT)  :: odilist_File !, odilist_CCDNr

   integer(kind=Int16) :: odiarray(0:nxdim-1,0:nydim-1)
   integer(kind=Int16) :: median_clo(1:nxdim) = 0, &
                          median_sci(1:nxdim) = 0, &
                          xrlvalue(1:nxdim) = 0, xrlodi = 0
   integer(kind=Int32) :: level_sci = 0, level_clo = 0
   integer :: ymin_ti = 13, ymax_ti = 200, ymin_bu = 13, ymax_bu = 180
   integer :: ymin_odi, ymax_odi
   real(kind=double) :: offmapcol(1:nydim) = 0.0

!-- epreject lower threshold handling MJF

   integer(kind=Int16) :: LowerThreshold, An_CMCOR, An_CMLOT
   integer(kind=Int32) :: Nbelow
   integer(kind=Int32), dimension(:), pointer :: flagCol
   type(ColumnT)       :: flag

   real(kind=double)   :: xmed
   real      :: XRL2PHAI = 0.0 ! 'a' coefficient a+b*X(RAWX)
   real      :: XRL2PHAS = 0.0 ! 'b' coefficient a+b*X(RAWX)
   logical   :: XRLCORR = .false. ! 'True', if the XRL has been corrected
   logical   :: withxrlcorrection = .false.
   logical   :: xrlstrict = .true. ! only for non-CLOSED-filters

!=======================================================================

   write(errstr,*) 'EPREJECT ',trim(CodeVersion),' is running...'
   call message(AppMsg,Verbose)

   i4spc = 0
   i4buf = 0
   i4buff = 0
   i4pmap = 0
   i30map = 0
   i2pmap = 0
   spcfrc = 0.
   median_clo(1:nxdim) = 0
   median_sci(1:nxdim) = 0
   xrlvalue(1:nxdim) = 0
   level_sci = 0
   level_clo = 0
   xrlodi = 0
   odibase(1:1024) = ' '

   withoffsetmap = booleanParameter("withoffsetmap")
   withoffsetlist = booleanParameter("withoffsetlist")
   withnoisehandling = booleanParameter("withnoisehandling")
   withsoftflarescreening = booleanParameter("withsoftflarescreening")
   odilist = stringParameter("odilist")
!
! open the event file in LOW_MEMORY:
! because EXPOSURE extensions are untouched (apart from header) and rather large
!
   infile = dataSet(stringParameter("eventset"),MODIFY,LOW_MEMORY)
   if (.not. hasBlock(infile,"EVENTS")) then
     call error("noEvents","No EVENTS extension in input data set")
   endif

   events = table(infile,"EVENTS",MODIFY)
   nevent = numberOfRows(events)

   if (hasBlock(infile,"EXPOSURE")) then
     expos = table(infile,"EXPOSURE",MODIFY)
     hasEXPOSUREalloc = .true.
     if (hasAttribute(expos,"XRLCORR")) then
       xrlcorr = booleanAttribute(expos,"XRLCORR")
     endif
   else
     call warning("NoExposureExt", &
                  "No EXPOSURE extension found: cannot read/write several keywords")
     hasEXPOSUREalloc = .false.
   endif

   if (hasAttribute(events,"DATAMODE")) then
     datamode = trim(stringAttribute(events,"DATAMODE"))
   else
     call warning("WrongSubMode","Could not read DATAMODE keyword; IMAGING assumed")
     datamode = "IMAGING"
   endif

   if (hasAttribute(events,"SUBMODE")) then
     submode = trim(stringAttribute(events,"SUBMODE"))
   else
     call warning("WrongSubMode","Could not read SUBMODE keyword; FF mode assumed")
     submode = "PrimeFullWindow"
   endif
   isubmode = modeId(trim(submode))
   isfastmode = ((isubmode .eq. FAST_TIMING) .or. &
                 (isubmode .eq. FAST_BURST))

   if (hasAttribute(infile,"EXPIDSTR")) then
     expidstr = trim(stringAttribute(infile,"EXPIDSTR"))
   else
     call warning("WrongSubMode","Could not read EXPIDSTR keyword; S003 assumed")
     expidstr = "S003"
   endif

   if (hasAttribute(events,"REJ_CORR")) then
     kw_rej_corr = trim(stringAttribute(events,"REJ_CORR"))
   else
     kw_rej_corr = "NO"
   endif

   if (hasAttribute(events,"XRL_CORR")) then
     kw_xrl_corr = trim(stringAttribute(events,"XRL_CORR"))
   else
     kw_xrl_corr = "NO"
   endif

   expo  = Real32Attribute(events,"EXPOSURE")
   exp1k = expo/1000.  ! s -> ks
!! expo  = expo / 2.16 ! eFF

   rawX = column(events,"RAWX",READ)
   rawY = column(events,"RAWY",READ)
   pha  = column(events,"PHA",MODIFY)
   flag = column(events,"FLAG",MODIFY)
   ccdnr = column(events,"CCDNR",READ)

   rawXCol     => int16Data(rawX)
   rawYCol     => int16Data(rawY)
   phaCol      => int16Data(pha)
   flagCol     => int32Data(flag)
   ccdCol      => int8Data(ccdnr)

   iccd = ccdCol(0)
!
! use this CCD number for later purposes
!
   if (withoffsetlist) then
!
! look for input file with list of offset maps
!
     inquire(file=odilist,exist=odilistfile_found)   
     if (.not.odilistfile_found) then
       call warning("NoOdilistFile", &
                  "No ODILIST found for this observation.")
       withoffsetlist = .false.
     else
       open(1,file=odilist,status="old")
!
! read through file until offset map for ICCD is found, or EOF
!
       odilistfile_found = .false.
       do mccd = 1,999999
         read(1,'(i2,1x,a)',end=997) jccd,odilistfile
         if (jccd == iccd) then
	   odilen = len(trim(odilistfile))
	   if (odilen.gt.0) then
             odilistfile_found = .true.
	     inquire(file=trim(odilistfile),exist=odilistfile_found)
	   endif
	   if (odilistfile_found) exit
         endif
       enddo
 997   continue
       if (.not.odilistfile_found) then
         call warning("NoOdilistFile", &
                  "No entry found in ODILIST for this CCD.")
         withoffsetlist = .false.
       endif
       close(1)
     endif
   endif ! (withoffsetlist)

!
! write previous "set" parameter content from input events file
!
   write(set,'(a9,a,a2,a3,a2,i2,a2,a1,a1)') &
              'ODF(EPN, ',trim(datamode),', ', &
              expidstr(2:4),', ',iccd,', ',expidstr(1:1),')'
   write(errstr,*)  "SET = ",trim(set)
   call message(AppMsg,Verbose)


   withxrlcorrection = booleanParameter("withxrlcorrection")
   if (withxrlcorrection) then
     if (isfastmode) then
       if (xrlcorr) then
         write(errstr,*) 'X-ray loading correction already applied, will not be applied again.'
         call warning('XRLcorrAlreadyApplied')
         withxrlcorrection = .FALSE.
       endif
     else
       write(errstr,*) 'Explicit X-ray loading correction only for FAST modes. For IMAGING modes this is done automatically here.'
       call warning('XRLcorrFastModeOnly')
       withxrlcorrection = .FALSE. ! had been handled previously at later stage in warning "notCalibrate"
     endif
   endif

   if (datamode .eq. "IMAGING") then
     if (kw_xrl_corr .eq. "YES") then
       call warning('XRLcorrDone','XRL correction already applied. To avoid double correction rest of task is skipped.')
       goto 969
     endif
     if (kw_rej_corr .eq. "YES") then
       call warning('REJcorrDone','epreject correction already applied. To avoid double correction rest of task is skipped.')
       goto 969
     endif
   endif
       
   if (.NOT.withsoftflarescreening) then

   offsig = realParameter("sigma")
   do i = 0,12
     noiseparam(i) = realParameter("noiseparameters",i)
   enddo

!-------------------------------------------------------
! open offset map
!
   if (withoffsetmap .or. withoffsetlist) then

!************* write value "set" from keywords of input events file *******!!!
     if (.not. withoffsetlist) then
!      shortfileName = trim(stringParameter('set'))
       shortfileName = trim(set)
       call OAL_expandFileName(shortfileName,fileName)
       call OAL_setState(fileName)
       hasoffsetmap = OAL_hasAssociatedSet(OFFSET_DATA)
       if (hasoffsetmap) odifile = OAL_selectAssociatedSet(OFFSET_DATA)
     else
!      hasoffsetmap =  existence of file in ODILIST
       odifile = trim(odilistfile)
       inquire(file=odifile,exist=hasoffsetmap)
     endif
     if (hasoffsetmap) then
       call basename(odifile,odibase)
       write(errstr,*) 'Offset map used: ',trim(odibase)
       call message(AppMsg,Sparse)
       odiset  = dataSET(trim(odifile),READ,USE_ENVIRONMENT)
       if (hasBlock(odiset,'PNODI1')) then
         odiarr  = array(odiset, "PNODI1", READ)
         ndim = numberOfDimensions(odiarr)
!
         if (ndim == 2) then       ! LBR
           i2offset => int16array2data(odiarr)
           odiarray(0:nxdim-1,0:nydim-1) = i2offset(0:nxdim-1,0:nydim-1) 
           write(errstr,'(2a)') 'Reading offset map ',trim(odifile)
           call message(AppMsg,Verbose)
         else if (ndim == 3) then  ! HBR
           call message(AppMsg,Noisy,"3D ODI found")
           i3offset => int16array3data(odiarr)
           odiarray(0:nxdim-1,0:nydim-1) = i3offset(0:nxdim-1,0:nydim-1,0)
           write(errstr,'(2a)') 'Reading offset map ',trim(odifile)
           call message(AppMsg,Sparse)
           write(errstr,'(a)') '+-----------------------------------------------+'
!          call message(AppMsg,Sparse)
           write(errstr,'(a)') '| HDI offset map: rerun epreject with parameter |'
!          call message(AppMsg,Sparse)
           write(errstr,'(a)') '| withoffsetmap=no if in doubt that this is the |'
!          call message(AppMsg,Sparse)
           write(errstr,'(a)') '| appropriate offset map for your observation!  |'
!          call message(AppMsg,Sparse)
           write(errstr,'(a)') '+-----------------------------------------------+'
!          call message(AppMsg,Sparse)
         else
           call error("CantReadOffsetMap", &
               "Does not seem to contain an ODI image: NAXIS neither 2 nor 3")
         end if
       else
         call error("CantReadOffsetMap", &
               "Incorrectly named extension in input ODI file")
       endif
!
     else
       withoffsetmap=.false.
       call warning("NoOffsetMap","No offset map found; using 20 ADU image instead")
       ndim = 2
       i2pmap = 0
       i2offset => i2pmap
     end if
   endif

   if (hasEXPOSUREalloc) then
     if (len(trim(odibase)).gt.0) then
!    if (withoffsetmap) then
       call setAttribute(expos,"OFSTFILE",trim(odibase), &
                         comment="Offset map used in correction")
       call setAttribute(expos,"OFSTCOR1","withOffsetMap", &
                         comment="Offset correction method")
     else
       call setAttribute(expos,"OFSTCOR1","with20aduImag", &
                         comment="Offset correction method")
     endif
     call setAttribute(expos,"OFSTCOR2",0,"",comment="Number of corrected events")
     call setAttribute(expos,"OFSTCOR3",0,"", &
                       comment="Number of events shifted below threshold")
     call setAttribute(expos,"OFSTCOR4",calibrated_offset,comment="Calibrated offset in CCF")
   endif

!-----------------------------------------------------------------------
! check FILTER keywords (used for X-ray loading corrections)
!-----------------------------------------------------------------------
   OTFILTER_Closed = .FALSE.
   if (hasAttribute(events,"OTFILTER")) then
     OT_FILTER = trim(stringAttribute(events,"OTFILTER"))
     hasOTFILTER = .TRUE.
     if (trim(OT_FILTER).eq."Closed") OTFILTER_Closed = .TRUE.
     write(errstr,'(a,a)') 'FILTER during offset map calculation: ',OT_FILTER
     call message(AppMsg,Sparse)
   else
     call warning("MissingFILTER","Could not read OTFILTER keyword.")
     hasOTFILTER = .FALSE.
   endif

   if (hasAttribute(infile,"FILTER")) then
     FILTER = trim(stringAttribute(infile,"FILTER"))
     hasFILTER = .TRUE.
     write(errstr,'(a,a)') 'FILTER during science observation:    ',FILTER
     call message(AppMsg,Sparse)
   else
     call warning("MissingFILTER","Could not read FILTER keyword.")
     hasFILTER = .FALSE.
   endif

   if (OTFILTER_Closed .and. withxrlcorrection .and. XRLstrict) then
     write(errstr,*) 'Filter during offset map calculation was "Closed" and therefore no XRL correction needed.'
     call message(AppMsg,Sparse)
     withxrlcorrection = .FALSE.
   endif

!-----------------------------------------------------------------------
! set CAL into proper state
!-----------------------------------------------------------------------
   call CAL_setState(instrument=EPN,ccdModeId=isubmode,ccdChipId=iccd)

!-----------------------------------------------------------------------
! initialize old NOISE handling stuff
!-----------------------------------------------------------------------
   calibrated_noise = .FALSE.
   map_min = -1.0
   map_max = -1.0
   if (withnoisehandling) then
     call message(AppMsg,Noisy,'reading from CCF: pnNoiseMap')
     call CAL_pnNoiseMap(rrawx,noisemap)
     map_min = MINVAL(noisemap(:,:,:))
     map_max = MAXVAL(noisemap(:,:,:))
     if (map_max .le. 0.0 .and. map_min .le. 0.0) then
       calibrated_noise = .FALSE.
     else
       calibrated_noise = .TRUE.
     endif

     if (.not. calibrated_noise) then
       write(errstr,*) "no noise calibration for submode ",trim(SUBMODE), &
                     ", skipping noise flagging"
       call warning("notCalibrated")
     endif
   endif
   if (.not. withnoisehandling) calibrated_noise = .FALSE.  !! MJF @ 2012-02-22

!-----------------------------------------------------------------------
! initialize OFFSET correction values
!-----------------------------------------------------------------------
   calibrated_offset = .FALSE.
   map_min = -1.0
   map_max = -1.0
   call message(AppMsg,Noisy,'reading from CCF: pnMedianMap')
   call CAL_pnMedianMap(r4med)
   map_min = MINVAL(r4med(:,:))
   map_max = MAXVAL(r4med(:,:))
   if (map_max .le. 0.0 .and. map_min .le. 0.0) then
     calibrated_offset = .FALSE.
     noffcorr = 1
     hlo => rdum
     hlo(0) = -2.2E-1
     hhi => rdum
     hhi(0) = +1.0E10
     val => i2dum
     val(0) = 0
   else
     calibrated_offset = .TRUE.
     call CAL_pnOffsetCorrValues(hlo,hhi,val)
     noffcorr = size(val)
   endif
   r4med=r4med*exp1k

!-----------------------------------------------------------------------
! get master offset map via CAL
!-----------------------------------------------------------------------
   if (withoffsetmap) then
     call message(AppMsg,Verbose,'reading from CCF: pnMasterOffset')
     call CAL_pnMasterOffset(MasterOffset)
   else
     write(errstr,*) 'Calibrated Offset:',calibrated_offset,noffcorr,hlo(0),hhi(0),val(0)
     call message(AppMsg,verbose)    
   endif

!-----------------------------------------------------------------------
! get X-ray loading correction parameters via CAL
!-----------------------------------------------------------------------
   if (withxrlcorrection) then
     if (isubmode .eq. FAST_TIMING) then
       ymin_odi = ymin_ti
       ymax_odi = ymax_ti
     elseif (isubmode .eq. FAST_BURST) then
       ymin_odi = ymin_bu
       ymax_odi = ymax_bu
     else
       ymin_odi = 1
       ymax_odi = nydim
       call warning("notCalibrated",'X-ray loading correction not calibrated for this mode')
     endif
!
! CAL map and parameters, compute median of each column
!
     call message(AppMsg,Verbose,'reading from CCF: pnMasterClosedOffsetMap')
     call CAL_pnMasterClosedOffset(MasterClosedOffset,XRLcoeff)
     xrl2phai = XRLcoeff(0)
     xrl2phas = XRLcoeff(1)
     write(errstr,*) " XRL correction coefficients:", XRLcoeff(0), XRLcoeff(1)
     call message(AppMsg,Sparse)
     do ix = 1,nxdim
       offmapcol(1:nydim) = MasterClosedOffset(ix-1,0:nydim-1)
       call median0(offmapcol(ymin_odi),ymax_odi-ymin_odi+1,xmed)
       median_clo(ix) = xmed
     enddo
!
! -> determine general level by average over 10 columns
!
     level_clo = 0
     do ix = glc1, glc2
       level_clo = level_clo+median_clo(ix)
     enddo
     level_clo = NINT((level_clo*1.d0)/(glc2-glc1+1))
!
! ODF map, compute median of each column
!
     call message(AppMsg,Verbose,'reading from ODF: pnOffsetMap')
     do ix = 1,nxdim
       offmapcol(1:nydim) = odiarray(ix-1,0:nydim-1)
       call median0(offmapcol(ymin_odi),ymax_odi-ymin_odi+1,xmed)
       median_sci(ix) = xmed
     enddo
!
! -> determine general level by average over 10 columns
!
     level_sci = 0
     do ix = glc1, glc2
       level_sci = level_sci+median_sci(ix)
     enddo
     level_sci = NINT((level_sci*1.d0)/(glc2-glc1+1))
!
     write(errstr,*) " Offset map general levels: CLO, SCI: ", level_clo, level_sci
     call message(AppMsg,Sparse)
!
! XRL correction of each column to be added later to PHA values
!
     call message(AppMsg,Verbose,'compute XRL correction from CCF')
     do ix = 1,nxdim
       xrlodi = (median_sci(ix)-level_sci) - (median_clo(ix)-level_clo)
       xrlvalue(ix) = NINT(XRL2PHAI + XRL2PHAS*xrlodi )
       write(errstr,'(A,i3,4i6)') "  IX, CLO, SCI, XRL:", &
              ix, median_clo(ix),median_sci(ix),xrlodi,xrlvalue(ix)
       call message(AppMsg,Verbose)
     enddo
     xrlcorr = .true.
   elseif (OTFILTER_Closed.and.XRLstrict) then
     xrlcorr = .false.
     XRL2PHAI = 0.0
     XRL2PHAS = 0.0
     call message(AppMsg,Sparse,'XRL coefficients set to zero for Closed (no correction applied).')
   else
     xrlcorr = .false.
     XRL2PHAI = 0.0
     XRL2PHAS = 0.0
     call message(AppMsg,Sparse,'XRL coefficients set to zero (no correction applied).')
   endif

!
! if neither "withoffsetmap" nor "calibrated_offset": skip rest
!
   if (.not. withoffsetmap .and. .not. calibrated_offset) then
     write(errstr,*) "no offset calibration for submode ",trim(SUBMODE), &
                     ", skipping rest of the task"
     call warning("notCalibrated")
   else

     rawX = column(events,"RAWX",READ)
     rawY = column(events,"RAWY",READ)
     pha  = column(events,"PHA",MODIFY)
     flag = column(events,"FLAG",MODIFY)

     rawXCol     => int16Data(rawX)
     rawYCol     => int16Data(rawY)
     phaCol      => int16Data(pha)
     flagCol     => int32Data(flag)

     winX0 = int16Attribute(events,"WINDOWX0")
     winY0 = int16Attribute(events,"WINDOWY0")
     winX1 = int16Attribute(events,"WINDOWDX") + winX0 - 1
     winY1 = int16Attribute(events,"WINDOWDY") + winY0 - 1
     mask(winX0:winX1,winY0:winY1)=.true.

!
! read and check keywords relevant for lower threshold [MJF]
!
   if (hasAttribute(events,"AN_CMLOT")) then
     An_CMLOT = int16Attribute(events,"AN_CMLOT")
   else
     call warning("MissingHKvalue","Could not read AN_CMLOT keyword; assuming 532 [adu]")
     An_CMLOT = 532
   endif
   if (hasAttribute(events,"AN_CMCOR")) then
     An_CMCOR = int16Attribute(events,"AN_CMCOR")
   else
     call warning("MissingHKvalue","Could not read AN_CMCOR keyword; assuming 512 [adu]")
     An_CMCOR = 512
   endif
   LowerThreshold = An_CMLOT - An_CMCOR
   if ((LowerThreshold .lt. 16) .or. (LowerThreshold .gt. 100)) then
     call warning("UnusualHKvalue","Unusual lower threshold, check keywords AN_CMLOT and AN_CMCOR.")
   endif

!
! append OFF_COR column
!
   if (hasColumn(events,"OFF_COR")) then
     offCor = column(events,"OFF_COR",MODIFY)
     offCol => int16Data(offCor)
   else
     offCor = addColumn (events, "OFF_COR", Integer16, "")
     offCol => int16Data(offCor)
     offCol = 0
   endif

!
! append XRL_COR column
!
  if (ldevel) then
   if (hasColumn(events,"XRL_COR")) then
     xrlCor = column(events,"XRL_COR",MODIFY)
     xrlCol => int16Data(xrlCor)
   else
     xrlCor = addColumn (events, "XRL_COR", Integer16, "")
     xrlCol => int16Data(xrlCor)
     xrlCol = 0
   endif
  endif

!-----------------------------
! bin 20 & 30-40 ADU images
!
   do i=0,nevent-1
     if (iccd /= ccdCol(i)) call error("Single CCD event file required")
     if ((phaCol(i)+offCol(i))==20) then
       i4pmap(rawXCol(i),rawYCol(i))=i4pmap(rawXCol(i),rawYCol(i))+1
     end if
     if (phaCol(i)+offCol(i)>=30 .and. phaCol(i)+offCol(i)<=40) then
       i30map(rawXCol(i),rawYCol(i))=i30map(rawXCol(i),rawYCol(i))+1
     end if
   end do
!
! read in bad columns and remove from mask
!
   string = stringParameter("badcolumnset")
   inquire(file=string,exist=exist)
   if (exist) then
     open(1,file=string,status="old")
     ios=0
     do while (ios == 0)
       read (1,*,iostat=ios) ccd, badX
       if (ios /= 0) exit
       if (ccd==iccd) mask(badX,winY0:winY1)=.false.
     end do 
     close(1)
   else
     if (.not. withoffsetmap) call warning ("No bad column table found","")
   endif
!
! get offset columns and remove from mask
!
   noffsets=0
   if (hasBlock(infile,"OFFSETS")) then
     offsets = table(infile,"OFFSETS",READ)
     noffsets = numberOfRows(offsets)

     if (noffsets > 0) then
       offX = column(offsets,"RAWX",READ)
       offXCol => int16Data(offX)

       do i=1,noffsets
         badX=offXCol(i-1)
         mask(badX,winY0:winY1)=.false.
       end do

       call release(offX)
     end if

     call release(offsets)
   end if
!
! get badpixels and remove from mask
!
   nbadpix=0
   if (hasBlock(infile,"BADPIX")) then
     badpix = table(infile,"BADPIX",READ)
     nbadpix = numberOfRows(badpix)

     if (nbadpix > 0) then
       bpRawX = column(badpix,"RAWX",READ)
       bpRawY = column(badpix,"RAWY",READ)
       yExtent = column(badpix,"YEXTENT",READ)

       bpRawXCol => int16Data(bpRawX)
       bpRawYCol => int16Data(bpRawY)
       yExtCol => int16Data(yExtent)

       do i=1,nbadpix
         do iy=bpRawYCol(i-1),bpRawYCol(i-1)+yExtCol(i-1)-1
           mask(bpRawXCol(i-1),iy)=.false.
         end do
       end do

       call release(bpRawX)
       call release(bpRawY)
       call release(yExtent)
     end if

     call release(badpix)
   end if
!
! remove rows < 16 from mask
!
  mask(:,1:15)=.false.
!
! source search in 30-40 ADU map
!
   nsou = 0
   do ix=winX0,winX1
     do iy=winY0,winY1
       count3=0
       pix3=0
       do ixx=ix-1,ix+1
         do iyy=iy-1,iy+1
           if (ixx >= 1 .and. ixx <= nxdim .and. &
             iyy >= 1 .and. iyy <= nydim) then
             if (mask(ixx,iyy)) then
               count3=count3+i30map(ixx,iyy)
               pix3=pix3+1
             end if
           end if
         end do
       end do
       count5=0
       pix5=0
       do ixx=ix-3,ix+3
         do iyy=iy-3,iy+3
           if (ixx >= 1 .and. ixx <= nxdim .and. &
             iyy >= 1 .and. iyy <= nydim) then
             if (mask(ixx,iyy)) then
               count5=count5+i30map(ixx,iyy)
               pix5=pix5+1
             end if
           end if
         end do
       end do
       count5=count5-count3
       pix5=pix5-pix3
       if (pix3>0 .and. pix5>0) then
         bgfac=real(pix3)/real(pix5)
         bg=real(count5)*bgfac
         if (count3>2 .and. count3-bg>10.*sqrt(bg)) then
           nsou = nsou+1
           write(errstr,'(a,2i4)') &
           "Masking source at position: ", ix, iy
           call message(AppMsg,sparse)
           do ixx=ix-1,ix+1
             do iyy=iy-1,iy+1
               if (ixx >= 1 .and. ixx <= nxdim .and. &
                   iyy >= 1 .and. iyy <= nydim) mask(ixx,iyy)=.false.
             end do
           end do
         end if
       end if
     end do
   end do

   win4Y0 = (winY0-1)/4
   win4Y0 = 4*win4Y0+1
!
! search for additional hot pixels
!
!   do ix = winX0, winX1
!     do iy = win4Y0, winY1, 4
!       h4mean(1)=(i4pmap(ix,iy+1)+i4pmap(ix,iy+2)+i4pmap(ix,iy+3))/3.
!       h4mean(2)=(i4pmap(ix,iy)  +i4pmap(ix,iy+2)+i4pmap(ix,iy+3))/3.
!       h4mean(3)=(i4pmap(ix,iy)  +i4pmap(ix,iy+1)+i4pmap(ix,iy+3))/3.
!       h4mean(4)=(i4pmap(ix,iy)  +i4pmap(ix,iy+1)+i4pmap(ix,iy+2))/3.
!       do i=1,4
!         if (i4pmap(ix,iy+i-1)-h4mean(i)>20.*sqrt(h4mean(i))) mask(ix,iy+i-1)=.false.
!       end do
!     end do
!   end do



   if (.not.withoffsetmap) then

    if (LowerThreshold == 20) then

     write(errstr,'(a,i2)') &
       "Determining offset corrections from 20 adu image for chip ", iccd
     call message(AppMsg,sparse)

     do ix = winX0, winX1
       do iy = win4Y0, winY1, 4

         kval=0
         hmed=0.
         do i=0,3
           ky=iy+i
           if (mask(ix,ky)) then
             kval = kval + i4pmap(ix,ky)
             hmed=hmed + r4med(ix-1,ky-1)
           end if
         end do

         if (abs(kval-hmed) > offsig*sqrt(real(kval))) then

           do ky=iy,iy+3

             if (mask(ix,ky)) then
               kval = i4pmap(ix,ky)
               hmed = r4med(ix-1,ky-1)

               do i=0,noffcorr-1
                 if (kval-hmed > hlo(i)*exp1k .and. &
                    kval-hmed <= hhi(i)*exp1k) &
                    i2pmap(ix,ky) = val(i)
              end do
             end if
           end do
         end if

       end do
     end do

    else
      call warning("Lower threshold != 20 adu: cannot perform offset correction !")
    end if

   else

     write(errstr,'(a,i2)') &
       "Determining offset corrections from offset map for chip ",iccd
     call message(AppMsg,sparse)
!
! compute and subtract the median value for each column:
!  print *, winx0, winx1, winy0, winy1
     i2pmap=0
     do ix = winX0, winX1
       k = 0
       do iy = max(winY0,nyStart), winY1
         k = k + 1
         if (ndim == 3) then
           i4arr1(k) = i3offset(ix-1,iy-1,1)
         else
           i4arr1(k) = i2offset(ix-1,iy-1)
         end if
       enddo
       call iindexx(k,i4arr1,indx)
       k = i4arr1(indx(k/2))
       !print *, ix, k
       do iy = winY0, winY1
         if (ndim == 3) then
           i2pmap(ix,iy) = i3offset(ix-1,iy-1,1) - k
         else
           i2pmap(ix,iy) = i2offset(ix-1,iy-1) - k
         end if 
       enddo
     enddo
!
! compute and subtract the median value for each row:
!
     do iy = max(winY0,nyStart), winY1
       k = 0
       do ix = winX0, winX1
       k = k + 1
         i4arr1(k) = i2pmap(ix,iy)
       enddo
       call iindexx(k,i4arr1,indx)
       k = i4arr1(indx(k/2))
       !print *, iy, k
       do ix = winX0, winX1
         i2pmap(ix,iy) = i2pmap(ix,iy) - k
       enddo
     enddo

     do ix=winX0,winX1
       do iy=winY0,winY1
         if (abs(i2pmap(ix,iy))>12) i2pmap(ix,iy)=0
       enddo
     enddo
     i2pmap = -i2pmap

     do ix=winX0,winX1
       do iy=winY0,winY1
         i2pmap(ix,iy) = i2pmap(ix,iy)+MasterOffset(ix-1,iy-1)
!         if (MasterOffset(ix-1,iy-1) /= 0) print *, "TEST:", ix,iy,MasterOffset(ix-1,iy-1)
       enddo
     enddo

   end if

!   i2pmap(:,1:20) = 0

   Nbelow = 0
   koff = 0
   do i=0,nevent-1
     ix = rawXCol(i)
     iy = rawYCol(i)
     if (min(ix,iy).lt.1 .or. ix.gt.nxdim .or. iy.gt.nydim) then
       call warning ("Invalid RawX, RawY")
       offCol(i) = 0
     else
      if (ldevel) then
       j2pha = phaCol(i) + offCol(i) - 1
       i2off = min(i2pmap(ix,iy),j2pha)                      !!! ... LIKE THIS ?? !!
       i2pha = phaCol(i) + offCol(i) - i2off		     !!! ... LIKE THIS ?? !!
      else
       i2off = min(i2pmap(ix,iy),i2offmax)    !!! THIS HAS TO BE CHANGED FOR THE NEXT RELEASE ... !!
       i2pha = phaCol(i) + offCol(i) - i2off  !!! THIS HAS TO BE CHANGED FOR THE NEXT RELEASE ... !!
      endif
       offCol(i) = i2off
       phaCol(i) = i2pha
       if (i2off /= 0) koff = koff + 1
       if (i2pha > 0 .and. i2pha <= maxspec) &
                           i4buf(iy,i2pha) = i4buf(iy,i2pha) + 1
     endif

     if ( phaCol(i) .lt. LowerThreshold ) then
       flagCol(i) = ior(flagCol(i), EVATT_BELOW_ACCEPTANCE)
!      flagCol(i) = ior(flagCol(i), EVATT_TRAILING)
       Nbelow = Nbelow + 1
     endif

   end do

   write(errstr,'(i9,a,i9,a)') koff, ' of', nevent, ' events selected for offset correction'
   call message(AppMsg,Sparse)
   write(errstr,'(i9,a,i5,a)') Nbelow,' events shifted below threshold of ',LowerThreshold,' [adu]'
   call message(AppMsg,Sparse)

   if (hasEXPOSUREalloc) then
     call setAttribute(expos,"OFSTCOR2",koff,"","Number of corrected events")
     call setAttribute(expos,"OFSTCOR3",nbelow,"", &
     		   "Number of events shifted below threshold")
     call setAttribute(expos,"OFSTCOR4",calibrated_offset,comment="Calibrated offset in CCF")
   endif
   if (withxrlcorrection) then
     if (XRLCORR) then
       if (hasEXPOSUREalloc) then 
         call setAttribute(expos,"XRL2PHAS",XRL2PHAS,"","coefficient b in XRL relation")
         call setAttribute(expos,"XRL2PHAI",XRL2PHAI,"","coefficient a in XRL relation")
       endif
       call message(AppMsg,Sparse,'Correcting now PHA values for X-ray loading ...')
       do i = 0,nevent-1
         ix = rawXCol(i)
         phaCol(i) = phaCol(i) + xrlvalue(ix)
	 if (ldevel) xrlCol(i) = xrlvalue(ix)
       enddo
       call message(AppMsg,Sparse,'Corrected PHA values for X-ray loading.')
       if (hasEXPOSUREalloc) then
         call setAttribute(expos,"XRLCORR",XRLCORR,comment="whether corrected for XRL")
       endif
     endif
   endif

   if (calibrated_noise) then
!
! append NOISE column
!
   if (hasColumn(events,"NOISE")) then
     noise = column(events,"NOISE",MODIFY)
   else
     noise = addColumn (events, "NOISE", Integer16, "")
   end if
   noiseCol => int16Data(noise)
   noiseCol = 0
!
! spatial smoothing/filtering of the spectra:
!
   do k = 1, maxspec
     do j = 1, 19
       i4buff(j,k) = i4buf(j,k)
     end do
     do j = 20, nydim
       ky = 0
       do jy = max(j-10,20), min(j+10,nydim)
         ky = ky + 1
         i4med(ky) = i4buf(jy,k)
       end do
       call iindexx(ky,i4med,indx)
       i4buff(j,k) = i4med(indx((ky+1)/2))
     end do
   end do

   spcfrc=0.
   do i = minspec, maxspec
     do ky = 1, nydim
       h1 = noisemap(0,i-minspec,ky-1)
       h2 = real(max(i4buff(ky,i),1)) / expo

       spcfrc(ky,i) = amin1(amax1(h1/h2,0.0),noiseparam(0))
       spcfrc(ky,i) = spcfrc(ky,i) * noiseparam(iccd)

!       if (iccd.eq.4) then
!         spcfrc(ky,i) = spcfrc(ky,i) * 1.04
!       else if (iccd.eq.5) then
!         spcfrc(ky,i) = spcfrc(ky,i) * 1.07
!       else if (iccd.eq.6) then
!         spcfrc(ky,i) = spcfrc(ky,i) * 0.95
!       else if (iccd.le.3) then
!         spcfrc(ky,i) = spcfrc(ky,i) * 0.98
!       endif

     enddo
   enddo

!   open(1,file='spcfrc.dat',status='unknown')
!   do j = 1, nydim
!     write(1,'(40f5.2)') (spcfrc(j,k),k=20,maxspec)
!   end do
!   close(1)

!*******************************************************************************
! WARNING: the following code section uses an internal random number generator
!          rather than CAL routine, this may heve to be revised if needed !!!!!
!*******************************************************************************
   idum=-1
   ksel=0
   do i=0,nevent-1
     i2pha = phaCol(i)
     if (i2pha > maxspec) then
       noiseCol(i) = 0
     else
       iy = rawYCol(i)
       if (ran2(idum).gt.dble(spcfrc(iy,i2pha))) then   !!!!! see WARNING !!!!!
         noiseCol(i) = 0
       else
         noiseCol(i) = 1
         ksel = ksel + 1
       endif
     endif
   end do
!*******************************************************************************

   write(errstr,'(i9,a,f6.2,a)') &
                ksel,' events were noise flagged  (', &
                100.0*real(ksel)/real(nevent),' % )'
   call message(AppMsg,Sparse)
   write(errstr,'(1x,a,f12.2,a)') 'exposure: ',expo,' [s]'
   call message(AppMsg,Sparse)

   call release(noise)

   endif ! calibrated_noise

   call release(offCor)
   call release(rawX)
   call release(rawY)
   call release(pha)
   call release(flag)
!
! replace EVATT_TRAILING with EVATT_BELOW_ACCEPTANCE
! once EVATT_BELOW_ACCEPTANCE has been added to the
! PN rejection mask
!
   call setEventAttribute(events,EVATT_BELOW_ACCEPTANCE)
!  call setEventAttribute(events,EVATT_TRAILING)

   endif ! calibrated_offset

   call release(ccdnr)
   call release(rawX)
   call release(rawY)
   call release(pha)
   call release(flag)

   else ! TIMING mode flare screening





!---------------------------------------------------------------------------
!---------------------------------------------------------------------------
!-  Vadims flare code start
!---------------------------------------------------------------------------
!---------------------------------------------------------------------------

   time = column(events,"TIME",READ)
   pha = column(events,"PHA",READ)

   timeCol     => real64Data(time)
   phaCol      => int16Data(pha)


   if (isubmode .ne. FAST_TIMING) &
     call warning("WrongSubMode","Wrong observing mode: should be Timing Mode")

! append FLARE column
   if (hasColumn(events,"FLARE")) then
     flare = column(events,"FLARE",MODIFY)
   else
     flare = addColumn (events, "FLARE", Integer16, "")
   end if
   flareCol => int16Data(flare)
   flareCol = 0


   ndlc=2000000

!  withsoftflarescreening -- optional,type=bool,default=no; turns on flare screening code
!  softflarethreshold1 -- optional,type=real,default=8; threshold for flare screening
!  softflarethreshold2 -- optional,type=real,default=1; threshold for flare screening
!  softflaresmooth -- optional,type=string,default=BOX; smoothing method for flare screening (on of BOX, GAUSS, or FLARE)
!  softflareenergyrange -- optional,type=list<real>,default='0 60'; energy range for flare screening
!  softflaresmoothparams -- optional,type=list<real>,default='5 0 0'; smoothing parameters

   write(errstr,*) 'Soft flare screening started'
   call message(AppMsg,Sparse)


!-- energy range parameter
   npharangeelements=parametercount("softflareenergyrange")
   do i=0,npharangeelements-1
     thrpha(i) = intParameter("softflareenergyrange",i)
   end do
   if (npharangeelements == 1) then
     thrpha(1)= thrpha(0)
     thrpha(0)=0
   endif

!-- smoothing  parameters
!--  nsmoothelements=parametercount("softflaresmoothparams")
!--  do i=0,nsmoothelements-1
       smo(0) = realParameter("softflaresmoothparams",0)
!--  end do

!-- cutoff threshhold for boxcar smoothed lightcurve
     thrsig = realParameter("softflarethreshold1")

!--  make low energy lightcurve below PHA threshhold
!--
!!!!! PROBLEM: tbinsize is not an integer multiple of the frame time (5.96464 ms)
!!!!!          0.1 should be either 0.1013989 (17 FT) or 0.09543424 (16 FT) [s]
!    tbinsize = 0.1d0
     tbinsize = 0.09543424d0  !  mjf@2012-03-30
!!!!!
     t0=timeCol(0)
     tz=timeCol(nevent-1)
     ndlc = NINT((tz-t0)/tbinsize)+3
     allocate(lc(1:ndlc),lcs(1:ndlc))
     lc=0d0
     kmax=0
     do i=0,nevent-1
       if (phaCol(i) .le. thrpha(1) .and. phaCol(i) .ge. thrpha(0)) then
	        k=nint((timeCol(i)-t0)/tbinsize)+1
	        if (k.ge.1 .and. k.le.ndlc) then
	          lc(k)=lc(k)+1
         else
           write(errstr,'(1x,a,i8,a,f7.4,a)') &
             'Lightcurve has more bins than intrinsically assigned ',&
              ndlc,' for ',tbinsize,' [s] bins'
	          call error("lightCurveBins")
!          call error("Lightcurve has more bins than intrinsically assigned")
	        endif
	      endif
       kmax=max(kmax,k)
     enddo

!--  smooth light curve with boxcar
!--

     sbox=nint(smo(0))
     do i = 1, kmax
       k=0
       ss=0
       do j = max(i-sbox,0), min(i+sbox,kmax)
	 if (j.ge.1 .and. j.le.ndlc) then
           ss=ss+lc(j)
           k=k+1
         endif
       enddo
       lcs(i) = ss/real(k)
     enddo

!--  set flare flag
!--
     flareCol=0
     flagged=0
     do i=0, nevent-1
       if (phaCol(i) .le. thrpha(1) .and. phaCol(i) .ge. thrpha(0)) then
          k=nint((timeCol(i)-t0)/tbinsize)+1
          if (lcs(k) .gt. thrsig) then
            flareCol(i)=1
            flagged=flagged+1
          end if
       endif
     enddo


   write(errstr,*) 'Soft flare screening completed ', flagged, ' of', nevent ,' events flagged'
   call message(AppMsg,Sparse)

   call release(flare)

   call release(time)
   call release(pha)

   deallocate(lc,lcs)

!---------------------------------------------------
!-  Vadims flare code end
!---------------------------------------------------
   end if

   kw_rej_corr = 'YES'
   call setAttribute(events,"REJ_CORR",kw_rej_corr,comment="whether corrected for offset map effects")

 969 continue

   if (hasEXPOSUREalloc) call release(expos)
   call release(events)
   call release(infile)

   if (ldebug) then

!   write debug images:
    call message(AppMsg,Sparse,"Writing debug images ...")

!      open(1,file='spcfrc.dat',status='unknown')
!      do j = 1, nydim
!        write(1,'(40f5.2)') (spcfrc(j,k),k=20,maxspec)
!      end do
!      close(1)

      npix(1) = nxdim
      npix(2) = nydim

      write(string,'(a4,i2.2,a4)') 'mask',iccd,'.img'
      outfile=dataset(string,Create)
      ima=addArray(outfile,"PRIMARY",Integer16,npix)
      i2map => Int16Array2Data(ima)

      do ix=0,nxdim-1
        do iy=0,nydim-1
          if (mask(ix+1,iy+1)) then
            i2map(ix,iy)=1
          else
            i2map(ix,iy)=0
          end if
        end do
      end do

      call release(ima)
      call release(outfile)

!      write(string,'(a6,i2.2,a4)') 'adu20_',iccd,'.img'
!      outfile=dataset(string,Create)
!      ima=addArray(outfile,"PRIMARY",Integer16,npix)
!      i2map => Int16Array2Data(ima)

!      do ix=0,nxdim-1
!        do iy=0,nydim-1
!          i2map(ix,iy)=i4pmap(ix+1,iy+1)
!        end do
!      end do

!      call release(ima)
!      call release(outfile)

       write(string,'(a6,i2.2,a4)') 'adu20_',iccd,'.img'
       outfile=dataset(string,Create)
       ima=addArray(outfile,"PRIMARY",Integer16,npix)
       i2map => Int16Array2Data(ima)

       do ix=0,nxdim-1
         do iy=0,nydim-1
           i2map(ix,iy)=i4pmap(ix+1,iy+1)
         end do
       end do

       call release(ima)
       call release(outfile)

      write(string,'(a6,i2.2,a4)') 'offcor',iccd,'.img'
      outfile=dataset(string,Create)
      ima=addArray(outfile,"PRIMARY",Integer16,npix)
      i2map => Int16Array2Data(ima)

      do ix=0,nxdim-1
        do iy=0,nydim-1
          i2map(ix,iy)=i2pmap(ix+1,iy+1)
        end do
      end do

      call release(ima)
      call release(outfile)

!      write(string,'(a6,i2.2,a4)') 'spcmap',iccd,'.img'
!      outfile=dataset(string,Create)
!      ima=addArray(outfile,"PRIMARY",Real32,npix)
!      r4map => real32Array2Data(ima)
!
!      do iy = 1, nydim
!        h = 0.0
!        do i = 22, 30
!          h = h + real(i4spc(iccd,iy,i))
!        end do
!        h = h / texp
!        do ix = 0, 63
!          r4map(ix,iy-1) = h
!        end do
!      end do

!      call release(ima)
!      call release(outfile)

!      write(string,'(a6,i2.2,a4)') 'bufmap',iccd,'.img'
!      outfile=dataset(string,Create)
!      ima=addArray(outfile,"PRIMARY",Real32,npix)
!      r4map => real32Array2Data(ima)

!      do iy = 1, nydim
!        h = 0.0
!        do i = 22, 30
!          h = h + real(i4buf(iy,i))
!        end do
!        h = h / texp
!        do ix = 0, 63
!          r4map(ix,iy-1) = h
!        end do
!      end do

!      call release(ima)
!      call release(outfile)

!      write(string,'(a6,i2.2,a4)') 'frcmap',iccd,'.img'
!      outfile=dataset(string,Create)
!      ima=addArray(outfile,"PRIMARY",Real32,npix)
!      r4map => real32Array2Data(ima)

!      do iy = 1, nydim
!        h = 0.0
!        do i = 22, 30
!          h = h + real(spcfrc(iy,i))
!        end do
!        do ix = 0, 63
!          r4map(ix,iy-1) = h
!        end do
!      end do

!      call release(ima)
!      call release(outfile)

   end if

   end subroutine epreject


!===============================================================================
      FUNCTION ran2(idum)
      INTEGER idum,IM1,IM2,IMM1,IA1,IA2,IQ1,IQ2,IR1,IR2,NTAB,NDIV
      DOUBLE PRECISION ran2,AM,EPS,RNMX
      PARAMETER (IM1=2147483563,IM2=2147483399,AM=1.d0/IM1,IMM1=IM1-1, &
      IA1=40014,IA2=40692,IQ1=53668,IQ2=52774,IR1=12211,IR2=3791, &
      NTAB=32,NDIV=1+IMM1/NTAB,EPS=1.2d-7,RNMX=1.d0-EPS)
      INTEGER idum2,j,k,iv(NTAB),iy
      SAVE iv,iy,idum2
      DATA idum2/123456789/, iv/NTAB*0/, iy/0/
      if (idum.le.0) then
        idum=max(-idum,1)
        idum2=idum
        do j=NTAB+8,1,-1
          k=idum/IQ1
          idum=IA1*(idum-k*IQ1)-k*IR1
          if (idum.lt.0) idum=idum+IM1
          if (j.le.NTAB) iv(j)=idum
        end do
        iy=iv(1)
      endif
      k=idum/IQ1
      idum=IA1*(idum-k*IQ1)-k*IR1
      if (idum.lt.0) idum=idum+IM1
      k=idum2/IQ2
      idum2=IA2*(idum2-k*IQ2)-k*IR2
      if (idum2.lt.0) idum2=idum2+IM2
      j=1+iy/NDIV
      iy=iv(j)-idum2
      iv(j)=idum
      if(iy.lt.1)iy=iy+IMM1
      ran2=min(AM*iy,RNMX)
      return
      END function ran2

!=======================================================================

SUBROUTINE median0(x, n, xmed)  ! taken from "epframes"

! Find the median of X(1), ... , X(N), using as much of the quicksort
! algorithm as is needed to isolate it.
! N.B. On exit, the array X is partially ordered.
!
!     Latest revision - 26 November 1996 [alan miller]
!     minor adaption for XMMSAS 24-05-2002 [mjf]
!
IMPLICIT NONE

INTEGER, INTENT(IN)                            :: n
REAL(kind=double), INTENT(INOUT), DIMENSION(:) :: x(1:n)
REAL(kind=double), INTENT(OUT)                 :: xmed

! Local variables

REAL(kind=double)    :: temp, xhi, xlo, xmax, xmin
LOGICAL              :: odd
INTEGER              :: hi, lo, nby2, nby2p1, mid, i, j, k

nby2 = n / 2
nby2p1 = nby2 + 1
odd = .true.
xmed = 0.0d0

! HI & LO are position limits encompassing the median.

IF (n == 2 * nby2) odd = .false.
lo = 1
hi = n
IF (n < 3) THEN
  IF (n < 1) THEN
    xmed = 0.0
    RETURN
  END IF
  xmed = x(1)
  IF (n == 1) RETURN
  xmed = 0.5d0*(xmed + x(2))
  RETURN
END IF

! Find median of 1st, middle & last values.

10 mid = (lo + hi)/2
xmed = x(mid)
xlo = x(lo)
xhi = x(hi)
IF (xhi < xlo) THEN          ! Swap xhi & xlo
  temp = xhi
  xhi = xlo
  xlo = temp
END IF
IF (xmed > xhi) THEN
  xmed = xhi
ELSE IF (xmed < xlo) THEN
  xmed = xlo
END IF

! The basic quicksort algorithm to move all values <= the sort key (XMED)
! to the left-hand end, and all higher values to the other end.

i = lo
j = hi
50 DO
  IF (x(i) >= xmed) EXIT
  i = i + 1
END DO
DO
  IF (x(j) <= xmed) EXIT
  j = j - 1
END DO
IF (i < j) THEN
  temp = x(i)
  x(i) = x(j)
  x(j) = temp
  i = i + 1
  j = j - 1

!     Decide which half the median is in.

  IF (i <= j) GO TO 50
END IF

IF (.NOT. odd) THEN
  IF (j == nby2 .AND. i == nby2p1) GO TO 130
  IF (j < nby2) lo = i
  IF (i > nby2p1) hi = j
  IF (i /= j) GO TO 100
  IF (i == nby2) lo = nby2
  IF (j == nby2p1) hi = nby2p1
ELSE
  IF (j < nby2p1) lo = i
  IF (i > nby2p1) hi = j
  IF (i /= j) GO TO 100

! Test whether median has been isolated.

  IF (i == nby2p1) RETURN
END IF
100 IF (lo < hi - 1) GO TO 10

IF (.NOT. odd) THEN
  xmed = 0.5d0*(x(nby2) + x(nby2p1))
  RETURN
END IF
temp = x(lo)
IF (temp > x(hi)) THEN
  x(lo) = x(hi)
  x(hi) = temp
END IF
xmed = x(nby2p1)
RETURN

! Special case, N even, J = N/2 & I = J + 1, so the median is
! between the two halves of the series.   Find max. of the first
! half & min. of the second half, then average.

130 xmax = x(1)
DO k = lo, j
  xmax = MAX(xmax, x(k))
END DO
xmin = x(n)
DO k = i, hi
  xmin = MIN(xmin, x(k))
END DO
xmed = 0.5d0*(xmin + xmax)

RETURN
END SUBROUTINE median0


subroutine basename(char1,char2)
character(len=*)   ,intent(in)    :: char1
character(len=*)   ,intent(out)   :: char2
integer                           :: ir,nr
nr = len(trim(char1))
do ir = nr,1,-1
! write(*,*) ir,'|',char1(ir:ir),'|'
  if (char1(ir:ir) .eq. '/') exit
enddo
if (ir.eq.0) then
  char2 = char1
! write(*,*) ' = |',trim(char1),'|',trim(char2),'|',ir,nr
else
  char2(1:nr-ir+1) = char1(ir+1:nr)
! write(*,*) ' < |',trim(char1),'|',trim(char2),'|',ir,nr
endif
end subroutine basename


end module epreject_mod
